#include <string.h>
#include <stdio.h>
#include <unistd.h>

#include <systypes/fcntl.h>

#include "debug.h"

/* Messages. */

char message[] = "Hello file!\n";



/* Main program. */

int main(int argc, char *argv[], char *envp[])
{
  FILE *fp;
  int fd;
  char buffer[100];
  int available;

  fd = open(argv[1], O_CREAT | O_RDWR);

  if (fd == -1)
  {
    debug("Failed to open file!\n");
    return 1;
  }

  /* Make a stream from the file descriptor. */

  fp = fdopen(fd, "r+");

  if (fp == NULL)
  {
    debug("Failed to open file as stream!\n");
    return 1;
  }

  /* Write a message for reading back. */

  if (!fwrite(message, sizeof(char), strlen(message), fp))
  {
    debug("Failed to write to file!\n");
    return 1;
  }

  if (fclose(fp))
  {
    debug("Failed to close file!\n");
    return 1;
  }

  /* Open a stream directly. */

  fp = fopen(argv[1], "r+");

  if (fp == NULL)
  {
    debug("Failed to open file!\n");
    return 1;
  }

  available = fread(buffer, sizeof(char), 100, fp);

  if (available == -1)
    debug("Failed to read file!\n");
  else if (!available)
    debug("Nothing read.\n");
  else
    debug_len(buffer, available);

  if (fclose(fp))
  {
    debug("Failed to close file!\n");
    return 1;
  }

  /* Finish off. */

  debug("At end of program!\n");

  return 0;
}
